#include "bmslsort.h"

DWORD  HeaderEdit::get_ex_style()   { return WS_EX_CLIENTEDGE; }
DWORD  HeaderEdit::get_style()      { return ES_LEFT | ES_AUTOHSCROLL; }

int HeaderSet::WIDTH = 200;
int HeaderSet::PADDING_TOP = 15;

int HeaderSet::EDIT_HEIGHT  = 20;
int HeaderSet::LABEL_HEIGHT = 15;


int HeaderSet::ONE_PADDING_RIGHT  = 10;
int HeaderSet::ONE_PADDING_LEFT   =  5;
int HeaderSet::ONE_PADDING_BOTTOM = 10;


int HeaderSet::count = 0;
HeaderSet *HeaderSet::ary[256] = { // 1 32
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };
BmsHeaderHash *HeaderSet::bms_hash = NULL_HEADER_HASH;
HFONT HeaderSet::h_font = NULL;

void HeaderSet::set_hash( BmsHeaderHash *hash ) {
  HeaderSet::bms_hash = hash;
}

void HeaderSet::set_font( HFONT h_font ) {
  HeaderSet::h_font = h_font;
  for ( int i = 0; HeaderSet::ary[i] != (HeaderSet *)0; ++i ) {
    HeaderSet::ary[i]->set_font( h_font );
  }
}

void HeaderSet::resize_all() {
  for ( int i = 0; HeaderSet::ary[i] != (HeaderSet *)0; ++i ) {
    HeaderSet::ary[i]->resize();
  }
}

void HeaderSet::repaint_edit_all() {
  for ( int i = 0; HeaderSet::ary[i] != (HeaderSet *)0; ++i ) {
    HeaderSet::ary[i]->repaint_edit();
  }
}

HeaderSet *HeaderSet::find_id( int id ) {
  for ( int i = 0; HeaderSet::ary[i] != (HeaderSet *)0; ++i ) {
    if ( HeaderSet::ary[i]->label_id == id || HeaderSet::ary[i]->edit_id == id ) {
      return HeaderSet::ary[i];
    }
  }
  return (HeaderSet *)0;
}

HeaderSet *HeaderSet::find_h_wnd( HWND target ) {
  for ( int i = 0; HeaderSet::ary[i] != (HeaderSet *)0; ++i ) {
    if ( HeaderSet::ary[i]->label->get_h_wnd() == target ||
         HeaderSet::ary[i]->edit->get_h_wnd()  == target ) {
      return HeaderSet::ary[i];
    }
  }
  return (HeaderSet *)0;
}

// instance
HeaderSet::HeaderSet( TtWindow *parent, const char *key, int label_id, int edit_id ) {
  this->index = HeaderSet::count;
  HeaderSet::count += 1;
  HeaderSet::ary[this->index] = this;
  
  this->key = BmsUtil::str_new_cpy( key, true );
  this->parent = parent;

  this->label_id = label_id;
  this->label = new TtStatic();
  this->label->create( this->parent, this->label_id, this->parent->get_h_instance(), NULL );
  this->label->set_font( HeaderSet::h_font );
  this->label->set_text( key );

  this->edit_id = edit_id;
  this->edit = new HeaderEdit();
  this->edit->create( this->parent, this->edit_id, this->parent->get_h_instance(), NULL );
  this->edit->set_font( HeaderSet::h_font );

  this->resize();

  this->label->show();
  this->edit->show();
}

HeaderSet::~HeaderSet() {
  delete this->key;
}

void HeaderSet::resize() {
  int one_height = EDIT_HEIGHT + LABEL_HEIGHT + ONE_PADDING_BOTTOM;
  int this_offset = PADDING_TOP + one_height * this->index;
  int one_width = WIDTH - ONE_PADDING_LEFT - ONE_PADDING_RIGHT;

  this->label->set_pos_size( ONE_PADDING_LEFT, this_offset, one_width, LABEL_HEIGHT );
  this->edit->set_pos_size( ONE_PADDING_LEFT,  this_offset + LABEL_HEIGHT, one_width, EDIT_HEIGHT );
}


int HeaderSet::repaint_edit() {
  return this->edit->set_text( HeaderSet::bms_hash->fetch_str( this->key ) );
}

bool HeaderSet::update_hash() {
  this->edit->get_text( BMSLSORT::buf, MAX_PATH );
  return HeaderSet::bms_hash->store( this->key, BMSLSORT::buf );
}
